import { PipeTransform } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * Cast super type into type using generics
 * Return Type obtained by assignment type.
 */
export declare class CastPipe implements PipeTransform {
    /**
    * Cast (S: SuperType) into (T: Type) using @Generics.
    * @param value S: SuperType obtained from input type.
    * @returns (T: Type) obtained by assignment type.
    */
    transform<S, T extends S>(value: S): T;
    static ɵfac: i0.ɵɵFactoryDeclaration<CastPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<CastPipe, "cast">;
}
